{ Demo na objektove programovani - setric obrazovky }
{                 (c) 1998 Jiri Smitka              }

uses Crt, Graph;

type
  PBod = ^TBod;
  TBod = object
    X,Y: Integer;
    constructor Init( X_, Y_: Integer);
    procedure Kresli; virtual;
    procedure Pohni; virtual;
    destructor Done; virtual;
    end;

  PKulicka = ^TKulicka;
  TKulicka = object (TBod)
    Polomer: Integer;
    constructor Init( X_, Y_, Polomer_: Integer);
    procedure Kresli; virtual;
    procedure Pohni; virtual;
    end;

  PCtverec = ^TCtverec;
  TCtverec = object (TBod)
    procedure Kresli; virtual;
    end;

constructor TBod.Init( X_, Y_: Integer);
begin
  X := X_;
  Y := Y_;
end;

procedure TBod.Pohni;
begin
  Inc( X, Random(3) - 1);
  Inc( Y, Random(3) - 1);
end;

procedure TBod.Kresli;
begin
end;

destructor TBod.Done;
begin
end;

{-----------------------------------------------------------------}

constructor TKulicka.Init( X_, Y_, Polomer_: Integer);
begin
  TBod.Init( X_, Y_);
  Polomer := Polomer_;
end;

procedure TKulicka.Kresli;
begin
  SetColor(14);
  Circle( X, Y, Polomer);
end;

procedure TKulicka.Pohni;
begin
  TBod.Pohni;
  Inc( Polomer, Random(3) - 1);
end;

{-----------------------------------------------------------------}

procedure TCtverec.Kresli;
begin
  SetColor(11);
  Rectangle( X-10, Y-10, X+10, Y+10);
end;

{-----------------------------------------------------------------}

var Gd, Gm: Integer;
    Pole: array [0..31] of PBod;
    X,Y,i: Integer;
begin
 Gd := Detect;
 InitGraph( Gd, Gm, '');       { zde nastav spravny adresar }
 if GraphResult <> grOk then Halt(1);

 Randomize;
 For i := 0 to high( Pole) do
   begin
   X := Random( GetMaxX - 20) + 10;
   Y := Random( GetMaxY - 20) + 10;
   if Random(2) = 0
     then Pole[i] := New( PKulicka, Init( X, Y, Random(10) + 5))
     else Pole[i] := New( PCtverec, Init( X, Y));
   end;

 repeat
   ClearDevice;
   For i := 0 to high( Pole) do Pole[i]^.Kresli;
   Delay(100);
   For i := 0 to high( Pole) do Pole[i]^.Pohni;
   until KeyPressed;

 ReadKey;

 For i := 0 to high( Pole) do
   Dispose( Pole[i], Done);

 CloseGraph;
end.
