{ Demo na objektove programovani - skakajici kulicky }
{                 (c) 1998 Jiri Smitka               }

uses Crt, Graph;

type
  PBod = ^TBod;
  TBod = object
    X,Y: Integer;
    VektorX, VektorY: Integer;
    Nahoru: Boolean;
    constructor Init( X_, Y_: Integer);
    procedure Kresli; virtual;
    procedure Pohni; virtual;
    destructor Done; virtual;
    end;

  PKulicka = ^TKulicka;
  TKulicka = object (TBod)
    Polomer: Integer;
    constructor Init( X_, Y_, Polomer_: Integer);
    procedure Kresli; virtual;
    end;

var
  MaxX, MaxY: Integer;

constructor TBod.Init( X_, Y_: Integer);
begin
  X := X_;
  Y := Y_;
  VektorX := Random(10) * (2 * Random(2) - 1);
  VektorY := Y_;
  Nahoru := false;
end;

procedure TBod.Pohni;
begin
  { X }
  Inc( X, VektorX);
  if X < 20 then begin
                   X := 20;
                   VektorX := -VektorX;
                 end
            else if X > MaxX then begin
                                    X := MaxX;
                                    VektorX := -VektorX;
                                  end;
  { Y }
  if Nahoru then Dec( Y, Round( 0.2 * (Y - VektorY)) + 1)
            else Inc( Y, Round( 0.2 * (Y - VektorY)) + 1);

  if Y <= VektorY
    then begin
           Y := VektorY;
           Nahoru := false;
         end
    else if Y > MaxY then begin
                            Y := MaxY;
                            Nahoru := true;
                          end;
end;

procedure TBod.Kresli;
begin
end;

destructor TBod.Done;
begin
end;

{-----------------------------------------------------------------}

constructor TKulicka.Init( X_, Y_, Polomer_: Integer);
begin
  TBod.Init( X_, Y_);
  Polomer := Polomer_;
end;

procedure TKulicka.Kresli;
begin
  SetColor(14);
  Circle( X, Y, Polomer);
end;

{-----------------------------------------------------------------}

var Gd, Gm: Integer;
    Pole: array [0..10] of PBod;
    X,Y,i: Integer;
begin
 Gd := Detect;
 InitGraph( Gd, Gm, '');       { zde nastav spravny adresar }
 if GraphResult <> grOk then Halt(1);

 Randomize;
 MaxX := GetMaxX - 20;
 MaxY := GetMaxY - 20;

 For i := 0 to high( Pole) do
   Pole[i] := New( PKulicka,
                 Init( Random( MaxX) + 10,
                       Random( MaxY) + 10,
                       Random(10) + 5));

 repeat
   ClearDevice;
   For i := 0 to high( Pole) do Pole[i]^.Kresli;
   Delay(100);
   For i := 0 to high( Pole) do Pole[i]^.Pohni;
   until KeyPressed;

 ReadKey;

 For i := 0 to high( Pole) do
   Dispose( Pole[i], Done);

 CloseGraph;
end.
